﻿#Script to install Business Central (BC) add-in extension
#Be sure to have administration permission
#Please check all the paths below and then run F5

#NOTE: if the app is already installed!!!!
#1 Uninstall your Navigate Pro app from BC (user mode, from BC Web Client)
#2 unpublish the app

#Policy can give an error, if you have fixed a more restricted policy, by user. 
#Setting policy might be not necessary, it depends by the system
Set-ExecutionPolicy unrestricted

#Import BC standard script.
#Find BC installation folders (server/client) Note: change path below if BC is installed in a different folder
Import-Module 'C:\Program Files (x86)\Microsoft Dynamics 365 Business Central\130\RoleTailored Client\NavModelTools.ps1' -WarningAction SilentlyContinue | out-null
Import-Module 'C:\Program Files\Microsoft Dynamics 365 Business Central\130\Service\NavAdminTool.ps1' -WarningAction SilentlyContinue | Out-Null

#----------------------------------------------------------------------------------------------
#PARAMETERS: CHANGE

#Name of BC Server Instance: change
$ServiceTier = "dynamicsnav130"


#Folder of the "Navigate Pro".app file: change
$AppFolder = "C:\App\"

#----------------------------------------------------------------------------------------------

#CODE: DON'T CHANGE

$Version = "1.0.1.2"
$AppFile = "NavigatePro_1.0.1.2_RPBC130.app"
$AppName = "Navigate Pro"


#SYNC 
Sync-NAVApp -ServerInstance $ServiceTier -Name $AppName


#Unpublish-NAVApp -ServerInstance $ServiceTier -Name $AppName

Publish-NAVApp -ServerInstance $ServiceTier -Path "$AppFolder$AppFile" -SkipVerification

#SYNC 
Sync-NAVApp -ServerInstance $ServiceTier -Name $AppName

Install-NAVApp -ServerInstance $ServiceTier -Name $AppName -Version $Version


#SYNC 
Sync-NAVApp -ServerInstance $ServiceTier -Name $AppName
