﻿#Script to install Business Central (BC) add-in extension
#Be sure to have administration permission
#Please check all the paths below and then run F5

#NOTE: if the app is already installed!!!!
#1 Uninstall your Navigate Pro app from BC (user mode, from BC Web Client)
#2 unpublish the app

#Policy can give an error, if you have fixed a more restricted policy, by user. 
#Setting policy might be not necessary, it depends by the system
#Set-ExecutionPolicy unrestricted

#Import BC standard script.
#Find BC installation folders (server/client) Note: change path below if NAV is installed in a different folder
Import-Module 'C:\Program Files\Microsoft Dynamics 365 Business Central\190\Service\NavAdminTool.ps1' -WarningAction SilentlyContinue | Out-Null

#----------------------------------------------------------------------------------------------
#PARAMETERS: CHANGE

#Name of BC Server Instance: change
$ServiceTier = "dynamicsnav190"


#Folder of the "Navigate Pro".app file: change
$AppFolder = "C:\App\"

#----------------------------------------------------------------------------------------------

#CODE: DON'T CHANGE

$Version = "100.0.4.0"
$AppFile = "NavigatePro_100.0.4.0_RPBC180.app" #Version 180 is compatible with latest versions
$AppName = "Navigate Pro"


#Unpublish-NAVApp -ServerInstance $ServiceTier -Name $AppName

Publish-NAVApp -ServerInstance $ServiceTier -Path "$AppFolder$AppFile" -SkipVerification

#SYNC 
Sync-NAVApp -ServerInstance $ServiceTier -Name $AppName

Install-NAVApp -ServerInstance $ServiceTier -Name $AppName -Version $Version


#SYNC 
Sync-NAVApp -ServerInstance $ServiceTier -Name $AppName