﻿#Script to install add-in extension
#Please check all the paths below and then run F5


#TO RUN SCRIPT PRESS F5!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#Import NAV standard script.
#Find Dynamics NAV installation folders (server/client) Note: change path below if NAV is installed in a different folder
Import-Module 'C:\Program Files (x86)\Microsoft Dynamics NAV\110\RoleTailored Client\NavModelTools.ps1' -WarningAction SilentlyContinue | out-null
Import-Module 'C:\Program Files\Microsoft Dynamics NAV\110\Service\NavAdminTool.ps1' -WarningAction SilentlyContinue | Out-Null



#----------------------------------------------------------------------------------------------
#PARAMETERS

#Name of NAV Server Instance: change
$MyServerInstance ='110_nav_w1_prod'   #i.e. $MyServerInstance='DynamicsNAV100'

#Navigate_Pro.navx Extension file: change
$MyNavxFile =  'C:\NAV Deploy Add-in\Extension\Navigate-Pro.navx'  #i.e. $MyNavxFile = 'C:\MyDirectory\Extension\Navigate-Pro.navx' 'C:\NavigatePro\Extension\Navigate-Pro.navx'

#Addin parameters: don't change
$MyAddInName= 'Navigate Pro'
$MyAddInDescription = 'Improved Navigation tool  www.infostudi.it'
$MyAddInVersion = '1.0.1.1'
$MyPermissionSetID= 'NAVIGATE PRO'

#----------------------------------------------------------------------------------------------

#Publish extension on "production" instance: don't change
Publish-NAVApp -Path $MyNavxFile -ServerInstance $MyServerInstance -SkipVerification -verbose

#Check if extension is found: don't change
Get-NAVAppInfo -ServerInstance $MyServerInstance 

#Extension Installation: don't change
Install-NAVApp -ServerInstance $MyServerInstance -Name $MyAddInName -Verbose

#Execute setup codeunits: don't change
Invoke-NAVCodeunit -ServerInstance $MyServerInstance  -CodeunitId 18004900 -verbose

#Create Permission Set: don't change
#Remove old Permission set. If it doesn't exist the system will prompt an error: ignore it.
Remove-NAVServerPermissionSet -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID

New-NAVServerPermissionSet -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -PermissionSetName 'Role for Navigate Pro'-Force
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 32   -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7316 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7317 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7318 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7319 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7320 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7321 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7322 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType TableData -ObjectId 7323 -Read Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 32   -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7316 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7317 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7318 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7319 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7320 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7321 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7322 -Execute Yes
New-NAVServerPermission -ServerInstance $MyServerInstance -PermissionSetId $MyPermissionSetID -ObjectType Table -ObjectId 7323 -Execute Yes
