

 codeunit 50137 IST_NPPartnerNavigateProMgtV2 
 {
     trigger OnRun()
     begin
         
     end;
     
  //This event is used to open your customized document In tabular Output
  [EventSubscriber(ObjectType::Table ,Database::IST_NPTabularOutput,'OnAfterOnOpenDocument','',false,false)]
  local procedure OnAfterOnOpenDocument(Rec: record IST_NPTabularOutput)
  var 
    SalesHeader :record "Sales Header";
  begin
    case Rec."Document Type" of
        Rec."Document Type"::"Partner Sales Quote": 
            begin
                //Find your own added document. i.e. Sales Header
                SalesHeader.GetBySystemId(Rec."System ID");
                //Run your own document page
                PAGE.RUNMODAL(PAGE::"Sales order", SalesHeader);  
            end;
    end;
  end;

 //This event is used to add content to customized fields on Tabular output table
  [EventSubscriber(ObjectType::Codeunit ,Codeunit::"IST_NP Interface",'onBeforeOpeningPageTabularOutput','',false,false)]
  local procedure OnAfterOnOpenDocument2(var tTmpTabularOutput: record IST_NPTabularOutput)
  var 
    SalesHeader :record "Sales Header"; //Just as an example
  begin

    IF not tTmpTabularOutput.findset then exit;
    
    repeat
      case tTmpTabularOutput."Document Type" of
          tTmpTabularOutput."Document Type"::"Partner Sales Quote": 
              begin
                tTmpTabularOutput."External Document No." :='Customer Content 123';
                tTmpTabularOutput."Special Requests"      := 'Ship all together';
                tTmpTabularOutput."Sent to Cloud Archive" := False; 
              end;

          tTmpTabularOutput."Document Type"::"Sales Order Archive": 
              begin
                tTmpTabularOutput."External Document No." :='Vendor Content 123';
                tTmpTabularOutput."Special Requests"      := 'Use one pallet';
                tTmpTabularOutput."Sent to Cloud Archive" := True; 
              end;

      end;
      tTmpTabularOutput.modify;
    until tTmpTabularOutput.next=0;
    
  end;



  [EventSubscriber(ObjectType::Codeunit,Codeunit::"IST_NP Interface", 'onBeforeShowingGraph', '', false, false)]
  procedure AppendMyOwnDocuments(var InJson: JsonObject; LastEntryNo: Integer; StartingDocRef: RecordRef)
  //This code is just for example (a working one). You can optimize as you wish.  
   var
    iJsonLastIndex: integer;
    myJsonObject: JsonObject;
    FieldRefDocumentType: FieldRef;
    FieldRefDocumentNo: FieldRef;
    FieldrefSystemId: FieldRef;
    SalesHeader: record "Sales Header";
    enumDocumentType: enum IST_NPDocumentType;
    guidSystemID: guid;
  

   begin
        //Note: this example shows how to append documents and relationships. By Deleting json file, you will be able to completely change the flow
        //Note2: Using wrong "Entry No." (see documentation), in the relationship part, can lead to a wrong drawing

        //Pay attention: using this way to personalize, some values will be typed and checked by application. In case of type mismatch you will receive an error
        //Typed "tags":
        //External Key (entry no): integer. It is the overall index
        //iLevel: integer
        //iDocType enum
        //sSystemID: guid
        //bDocExist: boolean
        //iLinkType :integer
        //iFatherEntryNo: integer (yes, i know, bad name choice, but hard to change now)
        //iDocEntryNo: integer
        //The last 2 tag must be existing EntryNo of documents, else no line will be drawn

        //Read the json file to find out all documents and relationship involved in the process
        //(i.e) ReadData(var InJson: JsonObject): DocumentsTable: record XXX;

        //Check what is the starting doc 
        case StartingDocRef.NUMBER of
           DATABASE::"Sales Header": 
            begin
              //Retrieving information about NAV Document Type and No. Here it depends by which is the initial document triggered.
              //If you added a "Partner Sales Quote", here you will look for that document
              //This part is useful to determine your searching routine.
              FieldRefDocumentType := StartingDocRef.FIELD(SalesHeader.FIELDNO("Document Type"));
              FieldRefDocumentNo   := StartingDocRef.FIELD(SalesHeader.FIELDNO("No."));
              enumDocumentType     := enumDocumentType::"Partner Sales Quote";
              FieldrefSystemId     := StartingDocRef.field(StartingDocRef.SystemIdNo);
              guidSystemID         := FieldrefSystemId.value;
              //(i.e.) FindDocuments(enumDocumentType,guidSystemID, XXX);

            end;
           DATABASE::"Purchase Header":
            begin
                //Do whatever you want
            end;
        else
         begin
          //exit; //Not handled documents
         end;

        end;
        
        //After having found all documents and relationship involved, fill the new json, or append the new part. Here it is shown just the way to add information
        //to json file


        //1 Get the last "EntryNo" used in Json 
        iJsonLastIndex:=LastEntryNo;

        //2 Start adding your own documents
        iJsonLastIndex+=1;
        

        Clear(myJsonObject);
        myJsonObject.Add('sType'       , 'Document'             ); //<<--- Fixed. It must be "Document"
        myJsonObject.Add('sTableName'  , 'My New Sales Order'   ); //<<--- Here you can put everything you want. Up to 3 lines. Central block. Normally it is Document Type caption. Too long word go to next line 
        myJsonObject.Add('sDocumentNo' , '22SO-00001'           ); //<<--- Here you can put everything you want. Up to 20 Chars. First line. Normally it is Document No. in a way readable for users
        myJsonObject.Add('iLevel'      , '1'                    ); //<<--- In which column I will draw the image (0-5): Must be an integer value
        myJsonObject.Add('sDate'       , '04/05/1988'           ); //<<--- Here you can put everything you want. Up to 20 Chars. Last line. Normally it is a Date (document, posting as you wish)
        myJsonObject.Add('sDescription', 'Here is Samuele'      ); //100.0.3.0 not yet used
        myJsonObject.Add('iDocType'    , format(enum::IST_NPDocumentType::"Sales Order".AsInteger())); //100.0.4.0 If you add your own document type in enum, use it
        myJsonObject.Add('sSystemID'   , '{00000000-0000-0000-0000-000000000000}'                   ); //100.0.4.0
        myJsonObject.Add('bDocExists'  , '1'                                                        ); //100.0.4.0
        InJson.Add(Format(iJsonLastIndex), myJsonObject ); //<<--- Key to find data. EntryNo
        iJsonLastIndex+=1;
           
        Clear(myJsonObject);
        myJsonObject.Add('sType'       , 'Document'          ); 
        myJsonObject.Add('sTableName'  , 'My New Sales Quote'); 
        myJsonObject.Add('sDocumentNo' , '22SQ-009001'       ); 
        myJsonObject.Add('iLevel'      , '2'                 ); 
        myJsonObject.Add('sDate'       , '26/11/1976'        ); 
        myJsonObject.Add('sDescription', 'Hi I am Davide    '); 
        myJsonObject.Add('iDocType'    , format(enum::IST_NPDocumentType::"Partner Sales Quote".AsInteger())); 
        myJsonObject.Add('sSystemID'   , '{716ff242-409c-eb11-ac6b-000d3a2b6372}' ); 
        myJsonObject.Add('bDocExists'  , '1'       ); 
        InJson.Add(format(iJsonLastIndex), myJsonObject ); 
        iJsonLastIndex+=1;

        //3 Add relationship between custom documents and with original Navigate Pro flow
        Clear(myJsonObject);
        myJsonObject.Add('sType'         , 'Relationship'   ); //<<--- Fixed. It must be "Relationshp"
        myJsonObject.Add('iFatherEntryNo', 3                ); //<<--- Starting point of the arrow line. The number is the document index inside the json
        myJsonObject.Add('iDocEntryNo'   , 1                ); //<<--- Ending point of the arrow line. The number is the document index inside the json
        myJsonObject.Add('iLinkType'     , '0'              ); //<<--- 0 full gray line, 1 dotted gray line. (don't use other numbers, they are not handle by engine)
        InJson.Add(format(iJsonLastIndex), myJsonObject     ); //<<--- Key to find data. EntryNo. Continue the documents index
        iJsonLastIndex+=1;

        Clear(myJsonObject);
        myJsonObject.Add('sType'         , 'Relationship'   );
        myJsonObject.Add('iFatherEntryNo', 3                ); 
        myJsonObject.Add('iDocEntryNo'   , 2                );  
        myJsonObject.Add('iLinkType'     , '1'              );
        InJson.Add(format(iJsonLastIndex), myJsonObject); 
       
    end;




[EventSubscriber(ObjectType::Page, Page::IST_NavigatePro,'OnDoubleClickEventJson','' , false, false)]
procedure PartnerDoubleClick(iEntryno:Integer; jsonData:JsonObject)
//Use this procedure to open selected documents
//bIsHandle is used to avoid running both types of personalization. bIsHandle must be set true by old version customization. So the system does not fire differente doubleclick 
//response routines
var
  enumDocumentType: enum IST_NPDocumentType;
  SalesHeader: record "Sales Header";
  guidSystemID: guid;
begin
    
    //Retrieve Document list, document type, entryno and systemid
    //i.e. FillDocumentList(jsonData)

    //Get the selected document
    //i.e. GetSelectDocument(var enumDocumentType, var guidSystemID)
    enumDocumentType:= enumDocumentType::"Partner Sales Quote";
    guidSystemID:='{716ff242-409c-eb11-ac6b-000d3a2b6372}';
    
    //open document. Note: opening an NP "document Type", you will fire 2 pages, the original and your custome
    Case enumDocumentType of
      enumDocumentType::"Partner Sales Quote": 
            begin
                //Find your own added document. i.e. Sales Header
                SalesHeader.GetBySystemId(guidSystemID);
                //Run your own document page
                PAGE.RUN(PAGE::"Sales Quote", SalesHeader);  
            end;

    End;
    
end;

[EventSubscriber(ObjectType::Page, Page::IST_NavigatePro,'OnRightClickEventDocTypeSystemID','' , false, false)]
local procedure RightClickEventDocTypeSystemID(enumDocumentType:enum IST_NPDocumentType; guidSystemID:guid; jsonData:JsonObject);
var
 
begin
    Message('Right Click New way Document Type %1 System Id %2', enumDocumentType,guidSystemID);

end;




}
